// VG93

//----------- COMMANDS

/*
00	nop
10	step forward
11	step back
12	step (previous)
13	step (vg93.trk -> vg93.data)
24	wait (com & 3)
25	wait 15ms ()
30	icount=0;
31	scount=0;	search sector index counter (4 spins-> not found)
40,x	wait address; success -> pos+=x
41,x	wait data field; success -> pos+=x
42,x	wait index.
50	fake read address
51	read (datalen) bytes;
52	write (datalen) bytes;
53	read to next index
54	write to next index
80,81	irq false/true
82,83	drq false/true
90,n	start cycle (n)
91	cycle loop (@90)
D0..7,x	if (bit(0..7),com) pos+=x
D8..F,x	if (!bit(0..7),com) pos+=x
E0,x	if (floppy.trk==0) pos+=x
E1,x	if (index) pos+=x
E2,x	if (vg93.trk != addres.trk) pos+=x
E3,x	if (vg93.sec != addres.sec) pos+=x
E4,x	if (com.side = addres.side) pos+=x
E5,x	if (scount<n) pos+=x
E7,x	jump x (pos+=x)
EA,x	if (vg93.trk = addres.trk) pos+=x
EB,x	if (vg93.trk = vg93.data) pos+=x
EC,x	if (vg93.drq = true) pos+=x;
F0..5	flag mode
F6,x	wait for index 0->1; if (succes & insert) +x
F8	seek error
F9	vg93.trk=0;
FA	vg93.trk +- 1 (on vg93.dir);
FB	record not found
FC	lost data
FD	vg93.sec = addr.trk
FE	vg93.sec++;
FF	end
*/

uchar vg93work[12][128]={
// 0	restore
	{0x80,0xf0,			// irq=0, flagmode=1
	0xe0,4,0x24,0x11,0xe7,-6,	// while (flop.trk != 0) flop.setp_back,wait
	0xf9,				// trk=0
	0xd2,2,0x81,0xff,		// if (!verify) return
	0x25,				// 15ms
	0x40,2,0x81,0xff,		// wait for address (return on error)
	0x50,				// read address
	0xea,1,0xf8,			// if (trk doesn't match) seekerror
	0x81,0xff},			// irq=1, stop
// 1	seek
	{0x80,0xf0,			// irq=0, flagmode=0
	0xeb,5,0x24,0x13,0xfa,0xe7,-7,	// while (trk!=data) step(trk->data) & update_trk
	0xd2,2,0x81,0xff,		// if (!verify) return
	0x25,				// 15 ms
	0x30,0x40,2,0x81,0xff,		// wait for address (4 rev -> interrupt)
	0x50,				// read address
	0xea,1,0xf8,			// if (trk doesn't match) seekerror
	0x81,0xff},			// irq=1, stop
// 2	step
	{0x80,0xf0,			// irq=0, flagmode=0
	0x24,0x12,0xdc,1,0xfa,		// step(prev); if (update) update_trk
	0xd2,2,0x81,0xff,		// if (!verify) return
	0x25,				// 15ms
	0x30,0x40,2,0x81,0xff,		// wait for address (4 rev -> interrupt)
	0x50,				// read address
	0xea,1,0xf8,			// if (trk doesn't match) seekerror
	0x81,0xff},			// irq=1, stop
// 3	step in
	{0x80,0xf0,
	0x24,0x10,0xdc,1,0xfa,		// same, step forward (to track 80 FIXME: 76?)
	0xd2,2,0x81,0xff,
	0x25,
	0x30,0x40,2,0x81,0xff,
	0x50,
	0xea,1,0xf8,
	0x81,0xff},
// 4	step out
	{0x80,0xf0,
	0x24,0x11,0xdc,1,0xfa,		// same, step back (to track 0)
	0xd2,2,0x81,0xff,
	0x25,
	0x30,0x40,2,0x81,0xff,
	0x50,
	0xea,1,0xf8,
	0x81,0xff},
// 5	read sector
	{0x80,0xf1,			// irq=0, flagmode=1
	0xda,1,0x25,			// if (delay) wait 15ms
	0x31,				// scount=0
	0xe5,3,0xfb,0x81,0xff,		// if scount>4 RNF
	0x30,0x40,3,0xfb,0x81,0xff,	// wait for address (4 rev -> record not found)
	0x50,				// read address
	0xe2,6,0xe3,4,			// if (trk or sec doesn't match) next
	0xd9,4,0xe4,2,			// if (side_compere_off or side_match) go read sector
	0xe7,-22,
	0x41,3,0xfb,0x81,0xff,		// wait data field (RNF if not found)
	0x51,				// read data
	0xd4,2,0x81,0xff,		// if (!multiply) return
	0xfe,0xe7,-36},			// sect+1; jp (@ 0x31)
// 6	write sector
	{0x80,0xf2,0x83,		// irq=0, flagmode=1, drq=1
	0xda,1,0x25,			// if (delay) wait 15ms
	0x31,				// scount=0
	0xe5,3,0xfb,0x81,0xff,		// if scount>4 RNF
	0x30,0x40,3,0xfb,0x81,0xff,	// wait for address (4 rev -> record not found)
	0x50,				// read address
	0xe2,6,0xe3,4,			// if (trk or sec doesn't match) next
	0xd9,4,0xe4,2,			// if (side_compere_off or side_match) go read sector
	0xe7,-22,
	0x41,3,0xfb,0x81,0xff,		// wait data field (RNF if not found)
	0x52,				// write data
	0xd4,2,0x81,0xff,		// if (!multiply) return
	0xfe,0xe7,-36},			// sect+1; jp (@ 0x31)
// 7	read addr
	{0x80,0xf3,			// irq=0, flagmode=3
	0xda,1,0x25,			// if (delay) wait 15ms
	0x30,0x40,3,0xfb,0x81,0xff,	// wait for address (RNF after 4 rev)
	0x51,				// read field (6 bytes)
	0xfd,				// sect = addr.trk
	0x81,0xff},			// irq=1, stop
// 8	read track
	{0x80,0xf4,			// irq=0, flagmode=4
	0xf6,2,0x81,0xff,		// wait index
	0x53,				// read until index 0->1
	0x81,0xff},			// irq=1, stop
// 9	write track
	{0x80,0xf4,0x83,		// irq=0, flagmode=4
	0xf6,2,0x81,0xff,		// wait index
	0x54,				// write until index 0->1
	0x81,0xff},			// irq=1, stop
// a	interrupt FIXME: conditions
	{0x81,0xff},
// b	something
	{0x81,0xff}
};

void VG93::command(uchar val) {
	if (!mr) return;			// no commands aviable during master reset
	if (wnum==0xff) {
		com=val;
		if ((val&0xf0)==0x00) {wnum=0; wpos=0;}	// restore
		if ((val&0xf0)==0x10) {wnum=1; wpos=0;}	// seek
		if ((val&0xe0)==0x20) {wnum=2; wpos=0;}	// step
		if ((val&0xe0)==0x40) {wnum=3; wpos=0;}	// step in
		if ((val&0xe0)==0x60) {wnum=4; wpos=0;}	// step out
		if ((val&0xe1)==0x80) {wnum=5; wpos=0;}	// read sector
		if ((val&0xe0)==0xa0) {wnum=6; wpos=0;}	// write secotr
		if ((val&0xfb)==0xc0) {wnum=7; wpos=0;}	// read address
		if ((val&0xfb)==0xe0) {wnum=8; wpos=0;}	// read track
		if ((val&0xfb)==0xf0) {wnum=9; wpos=0;}	// write track
		if (wnum==0xff) {wnum=11; wpos=0;}
	}
	if ((val&0xf0)==0xd0) {irq=true; wnum=255; count=0;}	// interrupt
}

uchar VG93::getflag() {
	uchar res=(fptr->insert?0:128) | ((wnum!=0xff)?1:0);
	switch (vg93.mode) {
		case 0: res |= (fptr->protect?64:0) | 32 | (seekerror?16:0) | ((fptr->trk==0)?4:0) | (fptr->index?2:0);
			break;
		case 1: res |= ((fld==0xf8)?32:0) | (notfound?16:0) | (lostdata?4:0) | (drq?2:0);
			break;
		case 2: res |= (fptr->protect?64:0) | (notfound?16:0) | (lostdata?4:0) | (drq?2:0);
			break;
		case 3: res |= (notfound?16:0) | (lostdata?4:0) | (drq?2:0);
			break;
		case 4: res |= (lostdata?4:0) | (drq?2:0);
			break;
		case 5: res |= (fptr->protect?64:0) | (lostdata?4:0) | (drq?2:0); break;
		default: res=0xff; break;
	}
	seekerror=false;
	lostdata=false;
	notfound=false;
	return res;
}

void VG93::setmr(bool z) {
	if (!mr && z) {		// 0->1 : execute com 3
		wnum=0xff;
		command(0x03);	// restore
		mr = z;
		sec = 1;
	} else {
		mr = z;
	}
}

void VG93::tick() {
	cop = (wnum==0xff)?0xff:vg93work[wnum][wpos];
	bool last = fptr->index;
	fptr->tick();
	uchar rtrk = fptr->rtrk;
	if (!last && fptr->index) {icount++; scount++;}
// VG93 tick
	if (count>0) {count--; return;}		// waiting
	if (wnum==0xff) return;			// idle
	uchar par1=vg93work[wnum][wpos+1];

if (traceout&& lop!=cop) {
	printf("%li:%li:%li\t",acount,intcount,inintcount);
	printf("%i:%i:%.2X\t\t",vg93.wnum,vg93.wpos,cop);
	printf("F: T:%i S:%i Sp:%i\t\t",fptr->trk,fptr->side,fptr->spin);
	printf("C: T:%i S:%i D:%i IR:%i DQ:%i\n",vg93.trk,vg93.sec,vg93.data,vg93.irq,vg93.drq);
}

	switch (cop) {
		case 0x00: wpos++; break;		// nop
		case 0x10: sdir = true; fptr->step(sdir); wpos++; break;		// step (to 80 trk)
		case 0x11: sdir = false; fptr->step(sdir); wpos++; break;		// step (to 0 trk)
		case 0x12: fptr->step(sdir); wpos++; break;				// step (last)
		case 0x13: if (trk != data) {sdir = (trk < data); fptr->step(sdir);}
			wpos++; break;
		case 0x24: count = bdi.turbo?1000:delays[com&3]; wpos++; break;
		case 0x25: count = bdi.turbo?0:104900; wpos++; break;			// 104900 - 15ms (unturbable :)
		case 0x30: icount=0; wpos++; break;
		case 0x31: scount=0; wpos++; break;
		case 0x40: if (icount<4) {if (fptr->field==1) wpos+=(par1+2);} else {wpos+=2;} break;
		case 0x41: if (icount<4) {if ((fptr->field==2) || (fptr->field==3)) wpos+=(par1+2);} else {wpos+=2;} break;
		case 0x42: if (!last && fptr->index) wpos+=2; break;
		case 0x50: if (fptr->field==0) {
				wpos++;
				if (traceout) {
					printf("%li:%li:%li\t",acount,intcount,inintcount);
					printf("%.2X %.2X %.2X %.2X\n",fptr->bufer[0],fptr->bufer[1],fptr->bufer[2],fptr->bufer[3]);
				}
			}
			break;
		case 0x51: if (fptr->field!=0 && fptr->spin==20) {
				fld=(fptr->field==2)?0xfb:0xf8;
				if (drq) {
					lostdata=true;
				} else {
					data=fptr->data[rtrk][fptr->pos];
					drq=true;
				}
			}
			if (fptr->field==0) wpos++;
			break;
		case 0x52: if (!fptr->protect) {
				if (fptr->field==0 && (fptr->fnext==3 || fptr->fnext==2)) fptr->data[rtrk][fptr->pos]=(com&1)?0xf8:0xfb;
				if ((fptr->field==3 || fptr->field==2) && fptr->spin==20) {
					if (drq) {
						lostdata=true;
					} else {
						fptr->data[rtrk][fptr->pos]=data;
						fptr->changed=true;
						drq=true;
					}
				}
			}
			if (fptr->field==0) wpos++;
			break;
		case 0x53: if (fptr->spin==20) {
				if (drq) {
					lostdata=true;
				} else {
					data=fptr->data[rtrk][fptr->pos];
					vg93.drq=true;
				}
			}
			if (!last && fptr->index) wpos++;
			break;
		case 0x54: if (fptr->spin==20) {
				if (drq) {
					lostdata=true;
				} else {
					fptr->data[rtrk][fptr->pos]=data;
					drq=true;
					fptr->changed=true;
				}
 			}
			if (!last && fptr->index) wpos++;
			break;
		case 0x80: irq=false; wpos++; break;
		case 0x81: irq=true; wpos++; break;
		case 0x82: drq=false; wpos++; break;
		case 0x83: drq=true; wpos++; break;
		case 0x90: ccnt=par1; wpos+=2; cpos=wpos; break;
		case 0x91: ccnt--; if (ccnt==0) wpos++; else wpos=cpos;
			break;
		case 0xd0:
		case 0xd1:
		case 0xd2:
		case 0xd3:
		case 0xd4:
		case 0xd5:
		case 0xd6:
		case 0xd7: wpos+=2; if (com & tmasks[cop & 7]) wpos+=par1; break;
		case 0xd8:
		case 0xd9:
		case 0xda:
		case 0xdb:
		case 0xdc:
		case 0xdd:
		case 0xde:
		case 0xdf: wpos+=2; if (!(com & tmasks[cop & 7])) wpos+=par1; break;
		case 0xe0: wpos+=2; if (fptr->trk==0) wpos+=par1; break;
		case 0xe1: wpos+=2; if (fptr->index) wpos+=par1; break;
		case 0xe2: wpos+=2; if (trk!=fptr->bufer[0]) wpos+=par1; break;
		case 0xe3: wpos+=2; if (sec!=fptr->bufer[2]) wpos+=par1; break;
		case 0xe4: wpos+=2; if (((com & 0x08)?1:0)==fptr->bufer[1]) wpos+=par1; break;
		case 0xe5: wpos+=2; if (scount<4) wpos+=par1; break;
		case 0xe7: wpos+=2; wpos+=par1; break;
		case 0xea: wpos+=2; if (trk==fptr->bufer[0]) wpos+=par1; break;
		case 0xeb: wpos+=2; if (trk==data) wpos+=par1; break;
		case 0xec: wpos+=2; if (drq) wpos+=par1; break;
		case 0xf0:
		case 0xf1:
		case 0xf2:
		case 0xf3:
		case 0xf4:
		case 0xf5: mode=(cop & 7); wpos++; break;
		case 0xf6: if (fptr->insert) {if (!last && fptr->index) wpos+=(par1+2);} else {wpos+=2;} break;
		case 0xf8: seekerror=true; wpos++; break;
		case 0xf9: trk=0; wpos++; break;
		case 0xfa: if (sdir) trk++; else trk--;
			wpos++;
			break;
		case 0xfb: notfound=true; wpos++; break;
		case 0xfc: lostdata=true; wpos++; break;
		case 0xfd: sec=fptr->bufer[0]; wpos++; break;
		case 0xfe: sec++; wpos++; break;
		case 0xff: wnum=0xff; break;
		default: printf("vg93 op %.2i:%.2i:#%.2X\n",wnum,wpos,vg93work[wnum][wpos]); throw(0); break;
	}
	lop=cop;
}

// BDI

int BDI::getport(int p) {
	int port = p;
	if (enable && active && (p & 0x03)==0x03) {
		if ((p & 0x82) == 0x82) port=0xff;
		if ((p & 0xe2) == 0x02) port=0x1f;
		if ((p & 0xe2) == 0x22) port=0x3f;
		if ((p & 0xe2) == 0x42) port=0x5f;
		if ((p & 0xe2) == 0x62) port=0x7f;
		pcatch = true;
// if (traceout) printf("BDI catch port: %.4X\t%.4X -> %.2X\n",pc,p,port);
	} else {
		pcatch=false;
	}
	return port;
}

void BDI::out(int port,uchar value) {
	switch (port) {
		case 0x1f: vg93.command(value); break;
		case 0x3f: vg93.trk=value; break;
		case 0x5f: vg93.sec=value; break;
		case 0x7f: vg93.data=value;
			vg93.drq=false;
			break;
		case 0xff: vg93.drv=value&0x03;
			vg93.fptr = &flop[vg93.drv];
			vg93.setmr(value&0x04);		// master reset
			vg93.block=(value&0x08);
			flop[vg93.drv].side=(value&0x10);
			vg93.mfm=(value&0x40);
			break;
	}
	if (traceout) {
		printf("%li:%li:%li\t",acount,intcount,inintcount);
		printf ("BDI out %.4X,%.2X\n",port,value);
	}
}

uchar BDI::in(int port) {
	uchar res=0xff;
	switch (port) {
		case 0x1f: res=vg93.getflag(); vg93.irq=false; break;
		case 0x3f: res=vg93.trk; break;
		case 0x5f: res=vg93.sec; break;
		case 0x7f: res=vg93.data; vg93.drq=false; break;
		case 0xff: res=(vg93.irq?128:0)|(vg93.drq?64:0); break;
	}
	if (traceout) {
		printf("%li:%li:%li\t",acount,intcount,inintcount);
		printf("BDI in %.2X (%.2X)\n",port,res);
	}
	return res;
}
